;
;  DOME SYSTEM BIOS
;

DOS 		.equ	0x0005
D_OPEN 		.equ	0x0F
D_SETDMA 	.equ	0x1A
D_READ 		.equ	0x27
D_CLOSE 	.equ	0x10
ENASLT 		.equ	0x24


CHIPS 		.equ	TAB_LOC-13
	; CHIPS   
	; 0b00000000   
	;          1 = FMPAC 
	;        11  = MUS / 256 KB YES/NO 
	;       1    = MOONSOUND
	;      1     = MSX-MIDI
	;     1      = FAC-MIDI
	;    1       = 
	;   1        =
INT_ON 		.equ	TAB_LOC-12	; 0=AAN 

SPRATR 		.equ	TAB_LOC-11
MOUSEY 		.equ	TAB_LOC-11
MOUSEX 		.equ	TAB_LOC-10
MOUSE_OFF 	.equ	TAB_LOC-9	;  AAN OF UIT 
MOUSE_USE 	.equ	TAB_LOC-8	;  " """""""" 
MOUSE_PORT 	.equ	TAB_LOC-7	;  PORT 1 OF 2 
MOUSE_WAIT1 	.equ	TAB_LOC-6	;  WAIT CYCLE 1 
MOUSE_WAIT2 	.equ	TAB_LOC-5	;  WAIT CYCLE 2 
MOUSE_BUTTONS 	.equ	TAB_LOC-4

MSX_TYPE 	.equ	TAB_LOC-3
DOSJMPTAB 	.equ	TAB_LOC-2

TAB_LOC 	.equ	0x0F00
DOME_BIOS 	.equ	0x0F00	; BIOS+GAMECODE(0x2500)+TANKTAB(0x3000)
DOME_VELD 	.equ	0x0F02	; THE LEVEL(0x4000)
DOME_CODE 	.equ	0x0F04	; THE DOME ENGINE(0x8000)
DOME_PAGE3 	.equ	0x0F06	; MORE ENGINE
DOME_MENU 	.equ	0x0F08	; GFX DOME MENU+CODE(0x8000)
DOME_TEMP 	.equ	0x0F0A	; 

DOME_CH_CODE 	.equ	0x0F0C	; LEVEL CHOOSER CODE
DOME_CH_GFX1 	.equ	0x0F0E	; LEVEL CHOOSE GFX 
DOME_CH_GFX2 	.equ	0x0F10	; GFX

DOME_MENT_CODE 	.equ	0x0F12	; CODE VOOR MENTAT
DOME_MENT1 	.equ	0x0F14	; BUFFER VOOR GFX MENTAT

DOME_GFX_UNIT 	.equ	0x0F16	; GAME GFX (UNIT)
DOME_GFX_BLPA 	.equ	0x0F18	; GAME GFX (BALK EN PAGE)

DOME_MMENU 	.equ	0x0F1A	; MAIN MENU GFX + CODE AT 4000

	; org	0x0100
.area	_CODE

ST:
C_01:	JP	GET_INT		;0x0100
C_02:	JP	PUT_INT		;0x0103
C_03:	JP	COLOR_WHITE	;0x0106
C_04:	JP	COLOR_BLACK	;0x0109
C_05:	JP	SCREEN_ON	;0x010C
C_06:	JP	SCREEN_OFF	;0x010F
C_07:	JP	SET_SCREEN0	;0x0112
C_08:	JP	SET_SCREEN5	;0x0115
C_09:	JP	SPRITES_ON	;0x0118
C_10:	JP	SPRITES_OFF	;0x011B
C_11:	JP	PUT_SPRITE	;0x011E
C_12:	JP	SET_PAGE	;0x0121
C_13:	JP	GET_TIME	;0x0124
C_14:	JP	PUT_TXT		;0x0127
C_15:	JP	PUT_TXT2	;0x012A
C_16:	JP	INIT_BIOS	;0x012D
C_17:	JP	EXIT_ON_ERR	;0x0130
C_18:	JP	LOAD		;0x0133
C_19:	JP	INIT_LIB	;0x0136
C_20:	JP	SAVE		;0x0139
C_21:	JP	PUT_PAGE_FD	;0x013C
C_22:	JP	PUT_PAGE_FE	;0x013F

C_23:	JP	M_MUSLOAD	;0x0142 
C_24:	JP	M_KITLOAD	;0x0145 
C_25:	JP	M_PLAY		;0x0148 
C_26:	JP	M_STOP		;0x014B 
C_27:	JP	M_CONT		;0x014E 
C_28:	JP	M_FADE		;0x0151 
C_29:	JP	M_LOC		;0x0154 
C_30:	JP	M_FREE		;0x0157

C_31:	JP	POP_UP_START	;0x015A
C_32:	JP	PUTBLK		;0x015D
C_33:	JP	PUT_COLOR	;0x0160
C_34:	JP	DOME_MENU_CALL	;0x0163
C_35:	JP	RESTORE_MEM	;0x0166
C_36:	JP	INIT_BIOS_MEM	;0x0169
C_37:	JP	RUN_GAME	;0x016C
C_38:	JP	INT_ROUTINE	;0x016F
C_39:	JP	HOOK_ON		;0x0172
C_40:	JP	HOOK_OFF	;0x0175
C_41:	JP	INIT_INT	;0x0178

C_42:	JP	M_MUSINFO	;0x017B
C_43:	JP	M_ADR		;0x017E
C_44:	JP	M_DRVINFO	;0x0181
C_45:	JP	M_DATA		;0x0184
C_46:	JP	DOSJMP		;0x0187

; clear data until ~DOME_MMENU=0x0F1A
;.ds	0x1000

INIT_BIOS:
	ld	e,#"2"
	ld	c,#0x02
	call	5
	DI

	POP	DE	; CALL ENTRY WEG !!!
	LD	(ST_STACK),SP
	PUSH	DE

	LD	HL,#INT_DOS
	CALL	GET_INT

	CALL	CHECK_IF_INST
	JR	NZ,INIT_BIOS_CONT		; NO MOONSOUND

	LD	A,(CHIPS)
	SET	3,A
	LD	(CHIPS),A	; SET MOON SOUND

	xor	a
	ld	de,#4*256+2	;D=4 E=2
	call	0xFFCA
	LD	(DOSJMPTAB),HL
	ld	a,c
	ld	bc,#0x0C
	add	hl,bc
	ld	de,#CALL_SEG_INIT
	ld	bc,#3
	ldir

	CALL	M_STOP
	CALL	M_FREE

	LD	DE,#0x8000
	CALL	M_ADR

	LD	B,#4
	JP	M_LOC

INIT_BIOS_CONT:
	xor	a
	ld	de,#4*256+2	;D=4 E=2
	call	0xFFCA
	LD	(DOSJMPTAB),HL

	LD	IY,#CALL_SEG
	LD	(IY),#0xC9	; ret
	LD	(IY),#0xC9	; ?>??????>>//???
	RET


CALL_SEG:
	ld	iy,(0xFB1E-1)
CALL_SEG_INIT:	JP	0xF200

; Check if replayer is installed
; output: if nz=0 not installed
;         if  z=1 installed

CHECK_IF_INST:
	LD	HL,#ID_FB04
	LD	DE,#0xFB04+21
	LD	B,#5
CHECK_IF_INST_LP:
	LD	A,(DE)
	CP	(HL)
	RET	NZ
	INC	HL
	INC	DE
	DJNZ	CHECK_IF_INST_LP
	RET

ID_FB04:.str	"MBTSR"	; If this is on address FB04h+21

;=============================

EXIT_ON_ERR:
	DI
	LD	SP,(ST_STACK)

	CALL	RESTORE_MEM	

	LD	HL,#INT_DOS
	CALL	PUT_INT
	CALL	SET_SCREEN0
	EI
	RET

GET_INT:
	DI
	LD	DE,#0x38+1

	LD	A,(DE)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	LD	(HL),A
	EI
	RET

PUT_INT:
	DI
	LD	DE,#0x38+1

	LD	A,(HL)
	LD	(DE),A
	INC	DE
	INC	HL
	LD	A,(HL)
	LD	(DE),A
	EI
	RET

COLOR_WHITE:
	DI
	LD	A,#0x0F
	OUT	(0x99),A
	LD	A,#0x87
	OUT	(0x99),A
	EI
	RET
COLOR_BLACK:
	DI
	XOR	A
	OUT	(0x99),A
	LD	A,#0x87
	OUT	(0x99),A
	EI
	RET

SPRITES_OFF:	LD	A,(0xFFE7)	; MOET ANDERS 
	OR	#0b00000010
	OUT	(0x99),A
	LD	A,#8+128
	OUT	(0x99),A
	RET

SPRITES_ON:	LD	A,(0xFFE7)	; MOET ANDERS 
	AND	#0b11111101
	OUT	(0x99),A
	LD	A,#8+128
	OUT	(0x99),A
	RET

PUT_SPRITE:
	LD	A,#1
	OUT	(0x99),A
	LD	A,#0x8E
	OUT	(0x99),A

	LD	A,#0x00	; ff    
	OUT	(0x99),A
	LD	A,#0x76	; 35    
	OUT	(0x99),A

	LD	BC,#0x0498
	OTIR
	RET

SCREEN_OFF:
	LD	IY,(0xFCC1)	; MOET ANDERS 
	LD	IX,#0x41
	CALL	0x1C
	EI
	RET
SCREEN_ON:
	LD	IY,(0xFCC1)	; MOET ANDERS 
	LD	IX,#0x44
	CALL	0x1C
	EI
	RET

SET_SCREEN5:
	LD	A,#5	; SCREEN 5  
	LD	IY,(0xFCC1)
	LD	IX,#0x5F
	CALL	0x1C
	EI
	RET
SET_SCREEN0:
	LD	A,#80
	LD	(0xF3AE),A
	LD	A,#0	; SCREEN 0  
	LD	IY,(0xFCC1)
	LD	IX,#0x5F
	CALL	0x1C
	EI
	RET


SET_PAGE:
	DI
	OUT	(0x99),A
	LD	A,#2+128
	OUT	(0x99),A
	EI
	RET

PUT_COLOR:
	DI
	XOR	A
	OUT	(0x99),A
	LD	A,#16+128
	OUT	(0x99),A

	LD	BC,#0x209A ; send 32(0x20) to 9A
	OTIR
	EI
	RET

GET_TIME:
	LD	C,#0x2C
	JP	DOS


NO_TXT:
	XOR	A
	LD	C,#2
	JP	DOS

PUT_TXT:
	LD	A,(0x0080)
	BIT	7,A
	JR	NZ,NO_TXT

	LD	A,(HL)
	CP	#0x1D
	JR	Z,PUT_TXT_DOME
	LD	E,A
	LD	C,#2
	PUSH	HL
	CALL	DOS
	POP	HL
	INC	HL
	JR	PUT_TXT
PUT_TXT_DOME:
	DI
	XOR	A
	OUT	(0x99),A	
	LD	A,#14+128
	OUT	(0x99),A
	XOR	A
	OUT	(0x99),A
	LD	A,#64
	OUT	(0x99),A
	LD	HL,#TXT_DOME
PUT_TXT_DOME2:
	LD	A,(HL)
	CP	#0x0A
	JR	Z,PUT_TXT_DOME3
	OUT	(0x98),A
	INC	HL
	JR	PUT_TXT_DOME2
PUT_TXT_DOME3:
	EI
	RET
PUT_TXT2:
	LD	A,(HL)
	CP	#0x1D
	RET	Z
	LD	E,A
	LD	C,#2
	PUSH	HL
	CALL	DOS
	POP	HL
	INC	HL
	JR	PUT_TXT2

ST_STACK:	.dw	0
INT_DOS:	.dw	0


TXT_DOME:	.str	"     DOME : The Building of an Empire / Beta"
		.str	" Release at XX-XX-1999"
		.db		0x0A



RESTORE_MEM:
	LD	HL,#MEM_ORG+6
	LD	B,(HL)
	LD	C,#0xC0
	CALL	PUT_SLT
	INC	HL
	LD	A,(HL)
	OUT	(0xFF),A

	LD	HL,#MEM_ORG
	LD	B,(HL)
	LD	C,#0x00
	CALL	PUT_SLT
	INC	HL

	LD	A,(HL)
	EXX
	LD	DE,#0x18
	CALL	DOS2_CALLTAB
	EXX
	INC	HL

	LD	B,(HL)
	LD	C,#0x40
	CALL	PUT_SLT
	INC	HL

	LD	A,(HL)
	EXX
	LD	DE,#0x1E
	CALL	DOS2_CALLTAB
	EXX
	INC	HL

	LD	B,(HL)
	LD	C,#0x80
	CALL	PUT_SLT
	INC	HL

	LD	A,(HL)
	EXX
	LD	DE,#0x24
	CALL	DOS2_CALLTAB
	EXX
	RET


DOS2_CALLTAB:
	LD	HL,(DOSJMPTAB)
	ADD	HL,DE
	PUSH	HL
	RET

PUT_PAGE_FD:
	LD	B,(HL)
	LD	A,(MEM_TAB+1) ;PAGE 1
	LD	C,#0x40
	CP	B
	CALL	NZ,PUT_SLT
	INC	HL
	LD	A,(HL)
	LD	DE,#0x1E
	LD	HL,(DOSJMPTAB)
	ADD	HL,DE
	PUSH	HL
	RET	

PUT_PAGE_FE:
	LD	B,(HL)
	LD	A,(MEM_TAB+2)	;PAGE 2
	CP	B
	LD	C,#0x80
	CALL	NZ,PUT_SLT
	INC	HL
	LD	A,(HL)
	LD	DE,#0x24
	LD	HL,(DOSJMPTAB)
	ADD	HL,DE
	PUSH	HL
	RET

PUT_PAGE_FF:
	LD	B,(HL)
	LD	A,(MEM_TAB+3)	;PAGE 3
	LD	C,#0xC0
	CP	B
	CALL	NZ,PUT_SLT

	INC	HL
	LD	A,(HL)
	OUT	(0xFF),A

	RET
PUT_SLT:
	PUSH	HL
	LD	A,B	; SLT ADR
	LD	H,C	; PAGE ADR
	CALL	ENASLT
	POP	HL
	RET

MEM_TAB:
	.ds	4
MEM_ORG:
	.ds	8

INIT_BIOS_MEM:
	LD	HL,#TAB_LOC
	LD	DE,#MEM_TAB
	LD	A,(HL)
	LD	(DE),A	; SLT ADR VAN PAGE 0
	INC	DE
	INC	HL
	INC	HL
	LD	A,(HL)
	LD	(DE),A	; SLT ADR VAN PAGE 1
	INC	DE
	INC	HL
	INC	HL
	LD	A,(HL)
	LD	(DE),A	; SLT ADR VAN PAGE 2
	INC	DE
	INC	HL
	INC	HL
	LD	A,(HL)
	LD	(DE),A	; SLT ADR VAN PAGE 3

	LD	HL,#TAB_LOC
	LD	DE,#MEM_ORG
	LD	BC,#8
	LDIR
	RET

M_MUSLOAD:
	LD	IX,#0x4000+(0*3)		; A=BANK
	JP	CALL_SEG		; DE=PIONTER2FILE(,0)
M_KITLOAD:
	LD	IX,#0x4000+(1*3)		; DE=PIONTER2FILE(,0)
	JP	CALL_SEG
M_PLAY:
	LD	IX,#0x4000+(2*3)		; A=BANK
	JP	CALL_SEG
M_STOP:
	LD	IX,#0x4000+(3*3)
	JP	CALL_SEG
M_CONT:
	LD	IX,#0x4000+(4*3)
	JP	CALL_SEG
M_FADE:
	LD	IX,#0x4000+(5*3)		; A=FADE SPEED
	JP	CALL_SEG
M_LOC:
	LD	IX,#0x4000+(6*3)		; B=NR OF SEGMENTS
	JP	CALL_SEG
M_FREE:
	LD	IX,#0x4000+(7*3)
	JP	CALL_SEG
M_MUSINFO:
	LD	IX,#0x4000+(8*3)		; DE=PIO2EMTYMEM(56)
	JP	CALL_SEG
M_ADR:
	LD	IX,#0x4000+(9*3)		; DE=MUS ADR
	JP	CALL_SEG
M_DRVINFO:
	LD	IX,#0x4000+(10*3)
	JP	CALL_SEG
M_DATA:
	LD	A,(0xFB1E)
	PUSH	HL
	LD	DE,#0x06
	LD	HL,(DOSJMPTAB)
	ADD	HL,DE
	PUSH	HL
	POP	DE
	POP	HL
	PUSH	DE
	RET

DOSJMP:
	LD	HL,(DOSJMPTAB)
	ADD	HL,DE
	PUSH	HL
	RET

PUTBLK:

	DI		; vdp klaar ?     
	LD	A,#2	; waarde 2 in reg 15     
	OUT	(0x99),A
	LD	A,#0x8F	; execute     
	OUT	(0x99),A
	NOP
	NOP		; wacht op vdp     
PUTBLK_WAIT:
	IN	A,(0x99)	;lees status     
	RRA		; is CE nog 1 dan C is loop     
	JR	C,PUTBLK_WAIT

	XOR	A	; status reg. op 0     
	OUT	(0x99),A
	LD	A,#0x8F
	OUT	(0x99),A

	LD	A,#0x20	; register 32     
	OUT	(0x99),A	; als control register     
	LD	A,#0x91	;in reg 17     
	OUT	(0x99),A
	LD	BC,#0x0F9B	; 15 bytes naar port 9b     
	OTIR
	EI

	RET


DOME_MENU_CALL:
	LD	HL,#DOME_MENU
	CALL	PUT_PAGE_FE
	
	;CALL	0x8000

	LD	HL,#COPY0_1
	CALL	PUTBLK

	LD	HL,#DOME_CODE
	CALL	PUT_PAGE_FE
	RET

INIT_INT:
	LD	HL,#INT_MAIN
	JP	PUT_INT

INT_MAIN:
	.dw	INT_ROUTINE


INT_ROUTINE:
	DI
	PUSH	AF
	PUSH 	BC
	PUSH 	DE
	PUSH 	HL
	EX	AF,AF
	EXX
	PUSH	AF
	PUSH 	BC
	PUSH 	DE
	PUSH 	HL

	PUSH	IX
	PUSH 	IY

	IN	A,(0x99)
	AND	A
	JP	P,I_NOT_V9938
	
	LD	A,(INT_ON)
	OR	A
	JR	NZ,INT_ON_OFF

	CALL	I_READ_BUTTONS
	CALL	READ_MOUSIE
	CALL	HOOK_VDP

INT_ON_OFF:
	POP	IY
	POP	IX

	POP	HL
	POP	DE
	POP	BC
	POP	AF
	EX	AF,AF
	EXX
	POP	HL
	POP	DE
	POP	BC
	POP	AF

	EI
	RETI

I_NOT_V9938:
	CALL	0xFD9A
	CALL	HOOK_INT
	POP	IY
	POP	IX
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	EX	AF,AF
	EXX
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	EI
	RETI
HOOK_VDP:
	CALL	HOOK_RET	; +1
	CALL	HOOK_RET	; +4
	CALL	HOOK_RET	; +7
	JP	HOOK_RET	; +10
HOOK_INT:
	CALL	HOOK_RET	; +13
	CALL	HOOK_RET	; +16
	CALL	HOOK_RET	; +19
	JP	HOOK_RET	; +21
HOOK_RET:
	RET

; HOOK_ON
; IN :	DE = 1/4/7/10(VDP) 13/16/19/21(NO VDP)
;	HL = ADR VAN TE AAN TE ROEPEN ROUTINE
;

HOOK_ON:
	DI
	PUSH	HL
	LD	HL,#HOOK_VDP
	ADD	HL,DE
	EX	DE,HL
	POP	HL

	LD	A,(HL)
	LD	(DE),A
	INC	DE
	INC	HL
	LD	A,(HL)
	LD	(DE),A
	EI
	RET
HOOK_OFF:
	DI
	LD	HL,#HOOK_VDP
	ADD	HL,DE
	EX	DE,HL

	LD	HL,#HOOK_RET
	LD	A,(HL)
	LD	(DE),A
	INC	DE
	INC	HL
	LD	A,(HL)
	LD	(DE),A
	EI
	RET

READ_MOUSIE:
	; Gebruik spratr om x en y op te slaan ! 

	LD	A,(MOUSE_PORT)	; Get mouse port in C 
	LD	C,A
MOUSE1:
	LD	A,(MOUSE_WAIT1)
	LD	B,A	; Get Y move 
	CALL	READ_MOUSE
	RLCA
	RLCA
	RLCA
	RLCA
	LD	H,A
	CALL	READ_MOUSE
	OR	H
	LD	H,A
	CALL	READ_MOUSE	; Get X move 
	RLCA
	RLCA
	RLCA
	RLCA
	LD	L,A
	CALL	READ_MOUSE
	OR	L
	LD	C,H	; B = X-move / C = Y-move 
	LD	B,A

	LD	A,B	; Move -1,-1 ? 
	INC	A
	LD	H,A
	LD	A,C
	INC	A
	OR	H
	JR	NZ,MOUSE3

	LD	A,(MOUSE_USE)	; Check mouse use 
	OR	A
	JR	NZ,MOUSE2

	LD	A,(MOUSE_PORT)	; Check other port 
	XOR	#0b01000000
	LD	(MOUSE_PORT),A

	JR	KEYBOARD

MOUSE2:
	LD	A,(MOUSE_OFF)	; na 20 keer -1,-1 is uit 
	INC	A
	LD	(MOUSE_OFF),A
	CP	#20
	JR	C,MOUSE4
	XOR	A	; Deactivate mouse 
	LD	(MOUSE_USE),A

	JR	KEYBOARD

MOUSE3:	; Activate mouse / Keep mouse activat 
	XOR	A	; counter op 0 
	LD	(MOUSE_OFF),A
	DEC	A	; wordt weer gebruikt 
	LD	(MOUSE_USE),A

MOUSE4:
	LD	A,B	; If mouse is moved then skip keyboar 
	OR	C
	JR	NZ,CHK_PIJL_BORD	; niet 0,0 dan check 

KEYBOARD:
	; nog even geen keyboard 
	RET


CHK_PIJL_BORD:	; In: B=y-coordinaat 

	LD	HL,#SPRATR
	LD	A,(HL)
	SUB	B

	BIT	7,B
	JR	NZ,CHK_PIJL_BORD_Y1
	JR	NC,CHK_PIJL_BORD_Y3
	XOR	A
	JR	CHK_PIJL_BORD_Y3

CHK_PIJL_BORD_Y1:
	JR	NC,CHK_PIJL_BORD_Y2
	CP	#204
	JR	C,CHK_PIJL_BORD_Y3

CHK_PIJL_BORD_Y2:
	LD	A,#203

CHK_PIJL_BORD_Y3:
	LD	(HL),A
	INC	HL

	LD	A,(HL)
	SUB	C
	BIT	7,C
	JR	NZ,CHK_PIJL_BORD_X1
	JR	NC,CHK_PIJL_BORD_X3
	XOR	A
	JR	CHK_PIJL_BORD_X3

CHK_PIJL_BORD_X1:
	JR	NC,CHK_PIJL_BORD_X2
	CP	#249
	JR	C,CHK_PIJL_BORD_X3
CHK_PIJL_BORD_X2:
	LD	A,#248

CHK_PIJL_BORD_X3:
	LD	(HL),A

MOUSE_SPRITE:
	DEC	HL
	; spratr in hl !! 

	LD	A,#1
	OUT	(0x99),A
	LD	A,#0x8E
	OUT	(0x99),A

	LD	A,#0x00	; ff  
	OUT	(0x99),A
	LD	A,#0x76	; 35  
	OUT	(0x99),A

	LD	BC,#0x0498
	OTIR
	RET

READ_MOUSE:
	LD	A,#15
	OUT	(0xA0),A
	LD	A,C
	OUT	(0xA1),A
	XOR	#0b00110000
	LD	C,A
	LD	A,#14
	OUT	(0xA0),A
READ_MOUSE_L:
	DJNZ	READ_MOUSE_L

	LD	A,(MOUSE_WAIT2)
	LD	B,A
	IN	A,(0xA2)
	AND	#0x0F
	RET

;-----------------------------------------

I_READ_BUTTONS:
	XOR	A
	CALL	I_FIR_P1
	LD	(MOUSE_BUTTONS),A
	RET

I_FIR_P1:
	LD	B,A	; A=0 PORT 1 / A=1 PORT 2   
	LD	A,#15

	OUT	(0xA0),A
	NOP
	IN	A,(0xA2)

	DJNZ	I_FIR_S1
	AND	#0xDF
	OR	#0x4C
	JR	I_FIR_S2
I_FIR_S1:
	AND	#0xAF
	OR	#3
I_FIR_S2:
	OUT	(0xA1),A
	LD	A,#14
	OUT	(0xA0),A
	NOP
	IN	A,(0xA2)
	RET

CHK_SPATIE:
	IN	A,(0xAA)	; check op spatie...        
	AND	#0xF0
	OR	#8
	OUT	(0xAA),A
	IN	A,(0xA9)
	AND	#1
	RET


RUN_GAME:
	PUSH	AF		; LEVEL NR

	;LD	HL,#INT_DOS
	;CALL	PUT_INT
	;HALT

	LD	HL,#DOME_CODE
	CALL	PUT_PAGE_FE
	LD	HL,#DOME_VELD
	CALL	PUT_PAGE_FD

	POP	AF
	DAA
	JP	C,EXIT_ON_ERR	; LEVEL NR HOGER DAN ==> QUIT

	LD	HL,#L_VELD_WR+2
	CALL	RUN_GAME_EXT
	LD	HL,#L_CODE_WR+2
	CALL	RUN_GAME_EXT
	LD	HL,#L_TANK_WR+2
	CALL	RUN_GAME_EXT

	LD	DE,#0x1000
	LD	BC,#0x500
	LD	HL,#L_CODE
	LD	A,#0
	CALL	LOAD

	CALL	0x100F		; BRIEFING CODE

	CALL	SCREEN_OFF

	LD	HL,#DOME_CODE
	CALL	PUT_PAGE_FE
	LD	HL,#DOME_VELD
	CALL	PUT_PAGE_FD

	LD	DE,#0x2000
	LD	BC,#0x1000
	LD	HL,#L_TANK
	LD	A,#0
	CALL	LOAD

	LD	DE,#0x4000
	LD	BC,#0x4000
	LD	HL,#L_VELD
	LD	A,#7		; 7 BYT HEADER 
	CALL	LOAD

	LD	DE,#0x8000
	LD	BC,#0x6000 	; 22 kb MAX
	LD	HL,#L_GAME
	LD	A,#0
	CALL	LOAD	


	LD	HL,#DOME_GFX_UNIT
	LD	A,(HL)
	OR	A
	JR	Z,NO_GFX_GAME1
	CALL	PUT_PAGE_FD

	LD	HL,#0x4000	; UNITTOT
	LD	DE,#0x0
	LD	A,#1
	CALL	POP_UP_START

	LD	HL,#DOME_GFX_BLPA
	LD	A,(HL)
	OR	A
	JR	NZ,NO_GFX_GAME2
	CALL	PUT_PAGE_FD

	LD	HL,#0x4000	; BALKEN 
	LD	DE,#0x8000
	LD	A,#0
	CALL	POP_UP_START

	LD	HL,#COPY0_1
	CALL	PUTBLK

	LD	HL,#DOME_VELD
	CALL	PUT_PAGE_FD

	LD	HL,#0x6000	; PAGE 5
	LD	DE,#0x8000
	LD	A,#1
	CALL	POP_UP_START

	LD	HL,#DOME_VELD
	CALL	PUT_PAGE_FD
	LD	HL,#DOME_CODE
	CALL	PUT_PAGE_FE

	LD	HL,#COLOR_DOME_GAME
	CALL	PUT_COLOR

	CALL	SCREEN_ON

	DI
	LD	A,#1
	CALL	M_PLAY

	JP	0x8000

NO_GFX_GAME1:
	LD	HL,#DOME_TEMP
	CALL	PUT_PAGE_FD

	LD	HL,#UNITTOT
	LD	DE,#0x4000	; OVER HET VELD
	LD	BC,#0x3000
	LD	A,#0
	CALL	LOAD
	LD	HL,#0x4000	; UNITTOT
	LD	DE,#0x0
	LD	A,#1
	CALL	POP_UP_START

NO_GFX_GAME2:
	LD	HL,#DOME_TEMP
	CALL	PUT_PAGE_FD

	LD	HL,#BALKEN4
	LD	DE,#0x4000
	LD	BC,#0x1000
	LD	A,#0
	CALL	LOAD
	LD	HL,#0x4000	; BALKEN 
	LD	DE,#0x8000
	LD	A,#0
	CALL	POP_UP_START
	LD	HL,#COPY0_1
	CALL	PUTBLK

	LD	HL,#PAGE5
	LD	DE,#0x4000
	LD	BC,#0x2000
	LD	A,#0
	CALL	LOAD
	LD	HL,#0x4000	; PAGE 5
	LD	DE,#0x8000
	LD	A,#1
	CALL	POP_UP_START

	LD	HL,#DOME_VELD
	CALL	PUT_PAGE_FD
	LD	HL,#DOME_CODE
	CALL	PUT_PAGE_FE

	LD	HL,#COLOR_DOME_GAME
	CALL	PUT_COLOR

	CALL	SCREEN_ON

	DI
	LD	A,#1
	CALL	M_PLAY

	JP	0x8000



RUN_GAME_EXT:
	

	RET



COPY0_1:
	.db	0,0,0,1
	.db	0,0,0,0
	.db	0,1,212,0
	.db	0,0,0xD0

L_VELD:		.str	"VELD    "
L_VELD_WR:	.str	"001"
L_CODE:		.str	"CODE    "
L_CODE_WR:	.str	"001"
L_TANK:		.str	"TANKTAB "
L_TANK_WR:	.str	"001"
L_GAME:		.str	"DOME    DAT"
BALKEN4:	.str	"BALKEN4 ZOP"
UNITTOT:	.str	"UNITTOT ZOP"
PAGE5:		.str	"PAGE5   ZOP"

COLOR_DOME_GAME:
	.db	#0x00,#0x00,#0x62,#0x04,#0x52,#0x03,#0x50,#0x02
	.db	#0x23,#0x02,#0x20,#0x01,#0x53,#0x04,#0x11,#0x01
	.db	#0x00,#0x04,#0x45,#0x04,#0x40,#0x01,#0x72,#0x05
	.db	#0x04,#0x01,#0x06,#0x02,#0x00,#0x00,#0x77,#0x07


;=======================================================================


POPPAG:	.db	0
POPIFF:	.db	0
POPEND:	.dw	0
POPXXX:	.dw	0
POPBUF:	.ds	256

POPTBL:
	.db	7	; Mapperbank ( niet gebruikt ? )
PAGE:	.db	0	; VDP-page (64 kB or b16 of VRAM-add  
DATA:	.dw	0	; Source address (in RAM)  
ADRES:	.dw	0	; Dest. address (in VRAM)  
	.dw	0	; End address (in VRAM, is calculated 


POP_UP_START:
	LD	(PAGE),A
	LD	(ADRES),DE
	LD	(DATA),HL

	LD	A,(MSX_TYPE)
	CP	#3
	LD	A,#0
	LD	IY,(0xFCC1)
	LD	IX,#0x0180
	CALL	Z,0x1C

	LD	A,(INT_ON)
	PUSH	AF
	LD	A,#255
	LD	(INT_ON),A

	XOR	A
	CALL	POP_UP

	POP	AF
	LD	(INT_ON),A

	LD	A,(MSX_TYPE)
	CP	#3
	RET	NZ
	LD	A,#2
	LD	IY,(0xFCC1)	; NUL (BIOS SLT)
	LD	IX,#0x0180
	JP	0x1C



POP_UP:	ADD	A
	ADD	A
	ADD	A
	LD	E,A
	LD	D,#0
	LD	IX,#POPTBL
	ADD	IX,DE	; [IX]=POPTBL+8*[A]

	LD	A,I	; IFF to P/V-flag
	LD	A,#-1 ; mm is FF -1
	JP	PE,POP_DI
	XOR	A
POP_DI:	LD	(POPIFF),A	; Interrupt status  (0: DI; -1: EI)

	LD	A,1(IX)
	LD	(POPPAG),A	; VDP-page (64 kB)

	LD	L,2(IX)
	LD	H,3(IX)	; Source address in [HL]
	LD	E,(HL)
	INC	HL
	LD	D,(HL)	; Length in [DE]
	LD	L,4(IX)
	LD	H,5(IX)	; Dest. address in [HL]
	ADD	HL,DE
	LD	(POPEND),HL	; Set end address

	LD	L,4(IX)
	LD	H,5(IX)	; Dest. address in [HL]
	CALL	POP_WR	; Set VDP to write

	LD	L,2(IX)
	LD	H,3(IX)	; Source address in [HL]
	LD	DE,#0x0004
	ADD	HL,DE	; Skip 4 bytes (the 2 addresses)
	LD	BC,#0x1098
	OTIR		; Write 1st 16 bytes in VRAM

	LD	E,#0x80
	EXX
	LD	L,4(IX)
	LD	H,5(IX)	; Dest. address in [HL]
	LD	DE,#0x0010
	ADD	HL,DE	; Skip 16 bytes
POP_00:	LD	A,(POPEND+1)
	CP	H
	JR	NZ,POP_01
	LD	A,(POPEND)
	CP	L
	RET	C
	RET	Z	; Return when (POPEND)<=[HL] 
POP_01:	EXX
	RLC	E
	JR	NC,POP_02
	LD	D,(HL)
	INC	HL
POP_02:	RLC	D
	LD	A,(HL)
	INC	HL
	JR	C,POP_03
	EXX

	CALL	POP_WR
	OUT	(0x98),A	; Write in VRAM 
	INC	HL
	JR	POP_00
;
POP_03:	BIT	7,A
	JR	NZ,POP_04
	EXX
	LD	D,#0x00
	LD	E,A
	EXX
	XOR	A
	JR	POP_05
;
POP_04:	BIT	6,A
	JR	NZ,POP_06
	RES	7,A
	LD	BC,#0x0400
POP_07:	RLC	E
	JR	NC,POP_08
	LD	D,(HL)
	INC	HL
POP_08:	RLC	D
	RLA
	RL	C
	DJNZ	POP_07
	ADD	A,#0x80
	EXX
	LD	E,A
	EXX
	LD	A,C
	ADC	A,#0x00
	EXX
	LD	D,A
	EXX
	LD	A,#0x01
	JR	POP_05
;
POP_06:	AND	#0x3F
	SRL	A
	EXX
	LD	D,A
	EXX
	LD	A,(HL)
	INC	HL
	RRA
	EXX
	LD	E,A
	EXX
	LD	A,#0x02
	JR	NC,POP_09
	LD	C,#0x01
	JR	POP_0A
;
POP_05:	LD	C,A
	INC	A
	RLC	E
	JR	NC,POP_0B
	LD	D,(HL)
	INC	HL
POP_0B:	RLC	D
	JR	NC,POP_09
POP_0A:	INC	A
	RLC	E
	JR	NC,POP_0C
	LD	D,(HL)
	INC	HL
POP_0C:	RLC	D
	JR	NC,POP_09
	INC	A
	RLC	E
	JR	NC,POP_0D
	LD	D,(HL)
	INC	HL
POP_0D:	RLC	D
	JR	NC,POP_09
	LD	A,#0x02
POP_0E:	RLC	E
	JR	NC,POP_0F
	LD	D,(HL)
	INC	HL
POP_0F:	RLC	D
	JR	NC,POP_10
	INC	A
	CP	#0x07
	JR	NZ,POP_0E
POP_10:	LD	B,A
	LD	A,#0x01
POP_11:	RLC	E
	JR	NC,POP_12
	LD	D,(HL)
	INC	HL
POP_12:	RLC	D
	RLA
	DJNZ	POP_11
	ADD	A,C
POP_09:	EXX

	PUSH	AF
	PUSH	HL

	LD	(POPXXX),HL	; write address in (popxxx) 
	SCF
	SBC	HL,DE	; read address in [HL] 
	LD	C,#0x98
	CALL	POP_13	; Simulate 'LDIR' in VRAM 

	POP	HL
	POP	AF
	LD	C,A
	LD	B,#0
	INC	BC
	ADD	HL,BC	; [HL#]=[HL]+[A]+1 
	JP	POP_00

POP_13:	LD	B,A
	INC	DE
	LD	A,D
	OR	A
	JP	NZ,POP_15	; [DE]>255 = [D]>0: no overlap 

	LD	A,B	; [B]=len-1 
	SUB	E	; [E]=x 
	JP	C,POP_15	; [B]<[E]: no overlap  (len<=x) 

	INC	B
	PUSH	BC
	LD	B,E
	CALL	POP_RD	; read address still in [HL] 
	LD	HL,#POPBUF
	INIR		; read x bytes in VRAM 

	LD	C,A
	LD	B,#0
	INC	BC	; [BC]=len-x 
	LD	HL,#POPBUF
	ADD	HL,DE
	EX	DE,HL	; [DE]=POPBUF+x 
	LD	HL,#POPBUF	; [HL]=POPBUF 
	LDIR

POP_14:	POP	BC
	LD	HL,(POPXXX)
	CALL	POP_WR
	LD	HL,#POPBUF
	OTIR		; write bytes in VRAM 
	RET

POP_15:	INC	B
	PUSH	BC
	CALL	POP_RD	; read address still in [HL] 
	LD	HL,#POPBUF
	INIR		; read bytes in VRAM 
	JP	POP_14

POP_WR:	PUSH	BC	; Set write address 
	LD	C,A
	LD	A,(POPPAG)
	LD	B,A
	LD	A,H
	AND	#0b11000000
	OR	B
	RLCA
	RLCA
	DI
	OUT	(0x99),A
	LD	A,#0x8E
	OUT	(0x99),A
	LD	A,L
	;LD	A,L
	OUT	(0x99),A
	LD	A,H
	AND	#0x3F
	OR	#0x40
	OUT	(0x99),A

	LD	A,(POPIFF)
	OR	A
	LD	A,C
	POP	BC
	RET	Z	; Restore int. status 
	EI
	RET

POP_RD:	PUSH	BC	; Set read address 
	LD	C,A
	LD	A,(POPPAG)
	LD	B,A
	LD	A,H
	AND	#0b11000000
	OR	B
	RLCA
	RLCA
	DI
	OUT	(0x99),A
	LD	A,#0x8E
	OUT	(0x99),A
	LD	A,L
	;LD	A,L
	OUT	(0x99),A
	LD	A,H
	AND	#0x3F
	OUT	(0x99),A

	LD	A,(POPIFF)
	OR	A
	LD	A,C
	POP	BC
	RET	Z	; Restore int. status 
	EI
	RET



SAVE:
	RET

; IF A=NOT 254 OR A=NOT 255 THEN
;
;	HL= FILE NAME		(LOAD_BIN)
;	DE= DMA-ADR
;	A=  HEADER TRACH	
;	BC= LENGTE
; ELSE
;	HL= FILE NAME		(LOAD_LIB)
;	DE= DMA-ADR
;
;	IF A=255 THEN CLOSE_LIB
; END


LOAD:
	JP LOAD_BIN
	;CP	#254		; CLOSE LIB ON EXIT
	;JR	C,LOAD_BIN	; KLEINER DAN

	;EX	AF,AF
	;PUSH	HL
	;CALL	SETDMA		; ADR
	;POP	HL
	;CALL	OPEN
	;CALL	SEARCH_FILE	; if found lengte in HL
	;CALL	READ
	
	;EX	AF,AF
	;CP	#255
	;RET	NZ
	;JP	CLOSE

;---------

PUT_TXT_FILE:
	LD	A,(HL)
	LD	E,A
	LD	C,#2
	PUSH	HL
	PUSH	BC
	CALL	DOS
	POP	BC
	POP	HL
	INC	HL
	DJNZ	PUT_TXT_FILE
	RET

FILE_ERROR:	.str	" NOT FOUND" ; 10 len

LOAD_BIN:
	PUSH	BC
	PUSH	AF
	PUSH	DE

	CALL	PUT_NAM_FCB
	CALL	OPEN
	cp #0
	jr z,store_open_f

; wip q&d error code;
	LD	HL,#FILENAME
	LD	B,#11
	CALL	PUT_TXT_FILE
	LD	HL,#FILE_ERROR
	LD	B,#10
	CALL	PUT_TXT_FILE
	ld	e,#0x0A
	ld	c,#0x02
	call	DOS
	ld	e,#0x0D
	ld	c,#0x02
	call	DOS

store_open_f:
	POP	DE
	CALL	SETDMA

	POP	HL
	; skip bytes ??
	LD	L,H	; KAN ??
	LD	H,#0
	CALL	READ	; kan dit ??

	POP	HL
	CALL	READ	; op oude DMA adres ???
	JP	CLOSE	; ja !! raar he ?!

; Zoek file op in directory en stel record number in
; In: HL: adres te laden file-naam
;     DE: adres directory
; Uit: HL: lengte file
;      A: 0 indien gelukt, 255 indien mislukt

SEARCH_FILE:
	LD	DE,#DIRECTORY	; eerste2 bytes zijn aantal files
SEARCH_FILE0:

	PUSH	HL	; adres naam v.d. file
	PUSH	DE	; adres directory

	CALL	CMP_STR
	OR	A
	JR	Z,SEARCH_FILE1

	POP	DE
	LD	HL,#11 + 2 + 3
	ADD	HL,DE
	EX	DE,HL	; DE = positie in directory
	POP	HL
	JR	SEARCH_FILE0

SEARCH_FILE1:                 ; HL = adres in directory
	EX	DE,HL

	LD	E,(HL)
	INC	HL
	LD	D,(HL)	; laad lengte
	INC	HL
	PUSH	DE

	LD	DE,#FCB + 33
	LD	BC,#3
	LDIR		; Record Number naar FCB

	XOR	A	; drive ??
	LD	(DE),A

	POP	HL	; lengte in HL

	POP	DE
	POP	DE
	RET

CMP_STR:
	LD	B,#11
CMP_STR1:
	LD	A,(DE)
	CP	(HL)
	RET	NZ
	INC	HL
	INC	DE
	DJNZ	CMP_STR1
	XOR	A
	RET



; Laad directory
; In: HL: Adres filename
;     DE: Bestemmingsadres directory

INIT_LIB:
	LD	DE,#DIRECTORY

	PUSH	DE
	PUSH	DE

	CALL	PUT_NAM_FCB	; put HL in FCB
	CALL	OPEN

	POP	DE
	CALL	SETDMA	; destination is DIRECTORY

	LD	HL,#2
	CALL	READ

	POP	HL	; In BC aantal files
	LD	C,(HL)
	INC	HL
	LD	B,(HL)

	LD	HL,#0
	LD	DE,#11 + 3 + 2	; lengte entry = name

CALC_LENGTH:
	ADD	HL,DE
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,CALC_LENGTH

	CALL	READ	; lees directory struct

	JP	CLOSE


;=========================================================================
;=========================================================================
;===================  SUBS  ==============================================
;=========================================================================
;=========================================================================


PUT_NAM_FCB:	;               ; In:  HL = file name pointer
	LD	DE,#FCB+1
	LD	BC,#0x0B		; Out: A  = drive name (0 = def., 1 =  
	LDIR			; Cng: HL,DE BC,AF       
	XOR	A
	LD	(FCB),A		;      (DRVNAM) must be valid    
	RET

SETDMA:
	LD	C,#D_SETDMA	; DE=ADR   
	JP	DOS
OPEN:
	LD	DE,#FCB
	LD	C,#D_OPEN
	CALL	DOS
	LD	HL,#0x01
	LD	(FCB+14),HL	; Record length = 1 byte    
	DEC	L
	LD	(FCB+33),HL
	LD	(FCB+35),HL	; Current record number = 0    
	RET

READ:
	LD	DE,#FCB
	LD	C,#D_READ	; HL=NR BYTES   
	JP	DOS

CLOSE:
	LD	DE,#FCB
	LD	C,#D_CLOSE
	JP	DOS

FCB:		.db	0
FILENAME:	.str	"           "
BLOCK:		.dw	#00
RECORDLENGTH:	.dw	#00
FILELENGTH:	.dw	#00,#00
SYSTEMVAR:	.dw	#00,#00,#00,#00,#00,#00
		.db	0
RECORDNR:	.dw	#00,#00

DIRECTORY:
		.db	0	; 7 BYTES PER FILE  OF 11+3+2 suckS
	;                        ; NAAM - LENGTE - REC.NUM

.area	_DATA
