
DOMELIB_NAME		:= domelib
DOMELIB_SRC			:= $(PATH_SRC)/$(DOMELIB_NAME)
DOMELIB_BIN			:= $(PATH_BIN)/$(DOMELIB_NAME)
DOMELIB_OUT			:= $(PATH_BIN)/$(DOMELIB_NAME)/dome.000
BUILD_HELP			+= \\n\\t* $(DOMELIB_OUT)
DOMELIB_DEPS		:= \
$(PATH_BIN)/bios/bios.dat \
$(PATH_BIN)/dome/dome.dat \
$(PATH_BIN)/loader/loader.dat \
$(PATH_BIN)/makelib/makelib.com \
$(PATH_BIN)/menu/menu.dat \
$(PATH_BIN)/mmenu/mmenu.dat

$(DOMELIB_BIN):
	$(call mb_mkdir,$(DOMELIB_BIN))

$(DOMELIB_BIN)/bios.dat: $(PATH_BIN)/bios/bios.dat | $(DOMELIB_BIN)
	cp $< $@;
$(DOMELIB_BIN)/dome.dat: $(PATH_BIN)/dome/dome.dat | $(DOMELIB_BIN)
	cp $< $@;
$(DOMELIB_BIN)/loader.dat: $(PATH_BIN)/loader/loader.dat | $(DOMELIB_BIN)
	cp $< $@;
$(DOMELIB_BIN)/makelib.com: $(PATH_BIN)/makelib/makelib.com bin/levels/code.001 bin/levels/code.002 | $(DOMELIB_BIN) gfx
	cp $< $@;
	cp bin/gfx/*.zop $(DOMELIB_BIN);
	cp bin/levels/*.00* $(DOMELIB_BIN);
	cp src/dist/*.zop $(DOMELIB_BIN);
	cp src/dist/*.COM $(DOMELIB_BIN);
	
$(DOMELIB_BIN)/menu.dat: $(PATH_BIN)/menu/menu.dat | $(DOMELIB_BIN)
	cp $< $@;
$(DOMELIB_BIN)/mmenu.dat: $(PATH_BIN)/mmenu/mmenu.dat | $(DOMELIB_BIN)
	cp $< $@;
	
$(DOMELIB_OUT): $(DOMELIB_BIN)/bios.dat $(DOMELIB_BIN)/dome.dat $(DOMELIB_BIN)/loader.dat $(DOMELIB_BIN)/makelib.com $(DOMELIB_BIN)/menu.dat $(DOMELIB_BIN)/mmenu.dat
	@echo === Generating autoexec.bat for command
	$(call mb_autoexec_write_default,$(DOMELIB_BIN))
	$(call mb_autoexec_append_echo,$(DOMELIB_BIN),Setup timeout for makelib)
	$(call mb_autoexec_append_cmd,$(DOMELIB_BIN),omsxctl fail_after 120 seconds fail_makelib 126)
	$(call mb_autoexec_append_echo,$(DOMELIB_BIN),Running command makelib)
	$(call mb_autoexec_append_cmd,$(DOMELIB_BIN),makelib)
	$(call mb_autoexec_append_exit,$(DOMELIB_BIN))
	$(call mb_openmsx_dos2, $(DOMELIB_BIN))
